-- 精灵续费
Lua_FairyExpireWindow = class("Lua_FairyExpireWindow", Lua_Window);
function Lua_FairyExpireWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FairyExpireWindow";
	self.skinName = "FairyExpireWindow_skin";
end

function Lua_FairyExpireWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.buff = Lua_NumberImage.new(self.content);
	self.buff.pivot = 2;
	self.buff.numWidth = 16;
	self.buff.prefix = "k_";
	self.buff.lastStr = "%";
	self.buff:setDepth(10);

	self.toolImage = Lua_ToolImage.new(self.content);
	self.toolImage:setDepth(8);
	self.toolImage:setLocation(124, -8, 0);

	self.desIcon:addLoadCompleteFun(self, self.onLoadCompleteFun);
	self.selectGold:addBoxChange(self, self.OnSelectGoldChange);
	self.selectCoupon:addBoxChange(self, self.OnSelectCouponChange);
	self.renewBtn:addClickFuntion(self, self.onRenewBtnClick);
end

function Lua_FairyExpireWindow:showWin(param)
	self:superCall("showWin", param);

	self.goldAndBindgold = false;
	if param.winType == nil or param.winType == 1 then
		if param.fairyVo.referenceIndex ~= nil then
			self.fairyVo = DataCenter.fairyData.fairyList[param.fairyVo.referenceIndex];
		else
			self.fairyVo = param.fairyVo;
		end
	elseif param.winType == 3 then
		if param.fairyPackItemData ~= nil then
			self.fairyVo = param.fairyPackItemData;
		end
	else
		if param.fairyPackItemData ~= nil then
			self.fairyVo = param.fairyPackItemData.fairyVo;
		end
	end

	local obj = getConfig({"fairy", self.fairyVo.index});
	self.itemId = obj.item_id;
	
	self.toolImage.data = Lua_ToolVo.createToolVo(obj.item_id, 1, 0);
	self.nameTxt.text = self.fairyVo.toolVo.name;

	self.moneyIcon3:setEnable(false);
	self.moneyTxt3:setEnable(false);
	if obj.money ~= nil and #obj.money > 0 then
		if obj.money[1][1] ~= 0 then
			self.moneyTxt1.text = obj.money[1][1];
		else
			self.moneyTxt1.text = self.fairyVo.toolVo.goldPrice;
		end

		if obj.money[2][1] ~= 0 then
			self.moneyTxt2.text = obj.money[2][1];
		elseif obj.money[3][1] ~= 0 then
			self.goldOrBindgold = true;
			self.addGold = obj.money[3][1];

			self.moneyTxt2.text = obj.money[3][2];
			self.moneyTxt3.text = obj.money[3][1].." +";

			local startPosX = self.moneyTxt3.mainContent.transform.localPosition.x + self.moneyTxt3.width + 6;
			self.moneyIcon2:setLocation(startPosX, -134, 0);
			startPosX = self.moneyIcon2.mainContent.transform.localPosition.x + self.moneyIcon2.width + 3;
			self.moneyTxt2:setLocation(startPosX, -136, 0);

			self.moneyIcon3:setEnable(true);
			self.moneyTxt3:setEnable(true);
		else
			self.moneyTxt2.text = self.fairyVo.toolVo.couponPrice;
		end
	else
		self.moneyTxt1.text = self.fairyVo.toolVo.goldPrice;
		self.moneyTxt2.text = self.fairyVo.toolVo.couponPrice;
	end

	if param.winType == 3 then
		self.tipsLab.text = LanUtil.getValue(140603);
		self.renewBtn.txt.text = LanUtil.getValue(140605);
		self.titleIcon:setAltas("fairyWindow_atlas", "ui_jlxf_z_05");
	else
		self.tipsLab.text = LanUtil.getValue(140604);
		self.renewBtn.txt.text = LanUtil.getValue(140606);
		self.titleIcon:setAltas("fairyWindow_atlas", "ui_jlxf_z_01");
	end

	self.selectGold.seleted = true;
	self.onSelect = 1;

	local imgName = {3, 2, 3, 3, 4}
	self.desIcon:setAltas("fairyWindow_atlas", "ui_jlxf_z_0"..imgName[self.fairyVo.index]);

	if self.fairyVo.index == 1 or self.fairyVo.index == 3 then
		self.buff.num = 50;
		self.buff:setLocation(140, 78);
	elseif self.fairyVo.index == 4 then
		self.buff.num = 70;
		self.buff:setLocation(140, 78);
	elseif self.fairyVo.index == 2 then
		self.buff.num = 20;
		self.buff:setLocation(110, 80);
	elseif self.fairyVo.index == 5 then
		self.buff.num = 20;
		self.buff:setLocation(37, 78);
	end
end

function Lua_FairyExpireWindow:onLoadCompleteFun()
	self.desIcon:resetSize();
end

function Lua_FairyExpireWindow:OnSelectGoldChange(val)
	if val == false then
		self.selectGold.seleted = true;
	else
		self.selectCoupon.seleted = false;
	end
	self.onSelect = 1;
end

function Lua_FairyExpireWindow:OnSelectCouponChange(val)
	if val == false then
		self.selectCoupon.seleted = true;
	else
		self.selectGold.seleted = false;
	end
	self.onSelect = 2;
end

function Lua_FairyExpireWindow:onRenewBtnClick(go)
	if self.showData.winType == nil or self.showData.winType == 1 then
		local param = {};
		param.fairyData = DataCenter.fairyData.fairyList[self.showData.fairyVo.referenceIndex];
		param.type = 1;
		if self.goldOrBindgold == true and self.onSelect == 2 then -- 元宝 + 礼金
			param.fairyData.money_type = 3;
		else
			param.fairyData.money_type = self.onSelect;
		end
		Lua_WindowUtil.openWin("Lua_FairyTipsWindow", WinParam.ACTION_OPEN, param);
		self:hide();
		return;
	end

	local bindGold = DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD);
	local gold = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	if self.onSelect == 1 then
		if gold < tonumber(self.moneyTxt1.text) then
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521), type = 1, subFun = self.openChargeWin});
		else
			self:exeSub();
		end
	else
		if self.goldOrBindgold == true and self.onSelect == 2 then
			if gold < tonumber(self.addGold) then
				Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521), type = 1, subFun = self.openChargeWin});
			elseif bindGold < tonumber(self.moneyTxt2.text) then
				OperateAlert.show(LanUtil.getValue(140607));
			else
				self:exeSub();
			end
		elseif bindGold < tonumber(self.moneyTxt2.text) then
			OperateAlert.show(LanUtil.getValue(140607));
		else
			self:exeSub();
		end
	end
	self:hide();
end

function Lua_FairyExpireWindow:openChargeWin()
	Lua_WindowUtil.openWin("Lua_FairyExpireWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN);
end

function Lua_FairyExpireWindow:exeSub()
	if self.showData.winType ~= nil and self.showData.winType == 3 then
		local dic = {};
		dic.itemId = self.itemId;
		if self.goldOrBindgold == true and self.onSelect == 2 then
			dic.money_type = 3;
		else
			dic.money_type = self.onSelect;
		end
		Lua_ProxyManager.getProxy("Lua_FairyProxy"):sBuyFairy(dic);
	else
		if self.goldOrBindgold == true and self.onSelect == 2 then
			self.showData.fairyPackItemData.money_type = 3;
		else
			self.showData.fairyPackItemData.money_type = self.onSelect;
		end
		Lua_ProxyManager.getProxy("Lua_FairyProxy"):sRenewalFairy(self.showData.fairyPackItemData);
	end
end

function Lua_FairyExpireWindow:dispose()
	if self.buff ~= nil then
		self.buff:dispose();
		self.buff = nil;
	end
	if self.toolImage ~= nil then
		self.toolImage:dispose();
		self.toolImage = nil;
	end

	self:superCall("dispose");
end