-- 精灵过期界面
Lua_FairySceneTipWindow = class("Lua_FairySceneTipWindow", Lua_Window);
function Lua_FairySceneTipWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FairySceneTipWindow";
	self.skinName = "FairySceneTipWindow_skin";
	self.layer = 500;
	self.isModel = false;
end

function Lua_FairySceneTipWindow:buildShowItem()
	self:superCall("buildShowItem");

	LuaUtil.setObjPos(self.content, MainWinDefine.V_width / 2 - 294, -MainWinDefine.V_height / 2 + 359, 0);

	self.itemImage = Lua_ToolImage.new(self.content);
	self.itemImage:setDepth(4);
	self.itemImage:setLocation(0, 49, 0);

	self.subBtn:addClickFuntion(self, self.onSubClick);
end

function Lua_FairySceneTipWindow:showWin(param)
	self:superCall("showWin", param);

	local tvo = Lua_ToolVo.new(param.fairyVo.itemId);
	self.itemImage.data = tvo;
	self.nameLab.text = tvo.colorName;

	if param.winType == nil or param.winType == 1 then
		self.tipsLab.text = param.fairyVo.tipsDes2;
		self.subBtn.label = LanUtil.getValue(110822);
	elseif param.winType == 2 then
		self.tipsLab.text = LanUtil.getValue(123507);
		self.subBtn.label = LanUtil.getValue(123506);
	end
end

function Lua_FairySceneTipWindow:onSubClick(go)
	local itemList = DataCenter.packData:getBagType(2):getItemsById(self.showData.fairyVo.itemId);
	local tempTime;
	if self.showData.winType == nil or self.showData.winType == 1 then
		if itemList ~= nil and itemList:getSize() > 0 then
			for i = 1, itemList:getSize() do
				tempTime = itemList[i].timeOut - DataCenter.roleData.serverTime;
				if itemList[i].timeOut == 0 or tempTime > 0 then
					if itemList[i] ~= nil then
						Lua_ProxyManager.getProxy("Lua_FairyProxy"):sPutOnFairy(itemList[i]);
						break;
					end
				end
			end
		end
	elseif self.showData.winType == 2 then
		if itemList ~= nil and itemList:getSize() > 0 then
			for i = 1, itemList:getSize() do
				tempTime = itemList[i].timeOut - DataCenter.roleData.serverTime;
				if itemList[i].timeOut ~= 0 and tempTime < 0 then
					Lua_WindowUtil.openWin("Lua_FairyExpireWindow", WinParam.ACTION_OPEN, {fairyPackItemData = itemList[i], winType = 2});
					break;
				end
			end
		end
	end
	self:hide();
end

function Lua_FairySceneTipWindow:dispose()
	if self.itemImage ~= nil then
		self.itemImage:dispose();
		self.itemImage = nil;
	end

	self:superCall("dispose");
end