-- 体验版精灵Tips
Lua_FairyTipsWindow = class("Lua_FairyTipsWindow", Lua_Window);
function Lua_FairyTipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FairyTipsWindow";
	self.skinName = "FairyTipsWindow_skin";
end

function Lua_FairyTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.subBtn:addClickFuntion(self, self.onSubClick);
	self.cancelBtn:addClickFuntion(self, self.hide);
end

function Lua_FairyTipsWindow:showWin(param)
	self:superCall("showWin", param);

	if param.type == nil or param.type == 1 then
		self.infoTxt:setEnable(false);

		self.fairyAttrItem = Lua_FairyAttrItem.new(self.content);
		self.fairyAttrItem:setData(param);

		self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(0, 0, 490, 190));
		self.dragContainer:setLocation(0, 23, 0);
		self.dragContainer:addSubContainer(self.fairyAttrItem, true);
		self.dragContainer:updateChildPos();
		self.dragContainer.canDrag = self.fairyAttrItem:getHeight() > 190;
	else
		self.infoTxt.text = LanUtil.formateStr(LanUtil.getValue(123501),
			tostring(param.fairyData.toolVo.goldPrice),
			tostring(param.fairyData.toolVo.couponPrice),
			tostring(param.fairyData.name));
	end
end

function Lua_FairyTipsWindow:onSubClick(go)
	local bindGold = DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD);
	local gold = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	local needBindGold = self.showData.fairyData.toolVo.couponPrice;
	local needGold = self.showData.fairyData.toolVo.goldPrice;
	if bindGold < needBindGold and gold < needGold then
		-- Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN);
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(122521),
			type = 1, subFun = self.openChargeWin});
	end

	self:exeSub();
	self:hide();
end

function Lua_FairyTipsWindow:openChargeWin()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN);
end

function Lua_FairyTipsWindow:exeSub(go)
	if self.showData.type == nil or self.showData.type == 1 then
		Lua_ProxyManager.getProxy("Lua_FairyProxy"):sBuyFairy(self.showData.fairyData);
	else
		Lua_ProxyManager.getProxy("Lua_FairyProxy"):sRenewalFairy(self.showData.fairyPackItemData);
	end
end

function Lua_FairyTipsWindow:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FairyAttrItem = class("Lua_FairyAttrItem", Lua_DragContainerItem);
function Lua_FairyAttrItem:ctor(p)
    self.height = 197;
    self:superCall("ctor", p);
end

function Lua_FairyAttrItem:buildShowItem()
	self:superCall("buildShowItem");

	self.infoTxt = UICreate.createLabel(self.content, "", -245, 95, 490, 22, 24);
	self.infoTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.infoTxt.pivot = UIWidget.Pivot.TopLeft;
	self.infoTxt.spacingY = 12;
end

function Lua_FairyAttrItem:setData(data)
	self.infoTxt.text = LanUtil.formateStr(LanUtil.getValue(123500), tostring(data.fairyData.toolVo.goldPrice),
		tostring(data.fairyData.toolVo.couponPrice), tostring(data.fairyData.name));

	local attrDic = data.fairyData.toolVo.attribute;
	local attrId;
	local attrTxt;
	local posY = self.infoTxt.mainContent.transform.localPosition.y - self.infoTxt.height - 10;
	for k,v in pairs(attrDic) do
		attrId = Lua_ThingDefine.getParamId(tostring(k));
		attrTxt = UICreate.createLabel(self.content,"", -79, posY, 200, 24, 24);
		attrTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		attrTxt.pivot = UIWidget.Pivot.TopLeft;
		attrTxt.text = "[FFB319]"..LanUtil.formateStr(Lua_ThingDefine.getParamName(attrId), tostring(v));

		posY = posY - 38;
	end
	self.height = attrTxt.mainContent.transform.localPosition.y + attrTxt.height
end

function Lua_FairyAttrItem:getHeight()
	return self.height;
end