Lua_ProbationFairyPurchaseWindow = class("Lua_ProbationFairyPurchaseWindow", Lua_ThirdSizeWindow);
function Lua_ProbationFairyPurchaseWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ProbationFairyPurchaseWindow";
	self.skinName = "ProbationFairyPurchaseWindow_skin";
	self.titleText = "精靈體驗";
	self.h = 400;
	self.w = 606;
end

function Lua_ProbationFairyPurchaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.titleBg:setLocation(0, 157);
	self.winBg:setLocation(0, -30);
	self.titleNameText:setLocation(0, 158);
	self.btnClose:setLocation(271, 158);

	self.purchaseBtn:addClickFuntion(self, self.onPurchaseClick);
	self.cancelBtn:addClickFuntion(self, self.hide);

	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(0, 0, 475, 230));
	self.purchasePanel = Lua_ProbationFairyPurchasePanel.new(self.content, self);
	self.dragContainer:addSubContainer(self.purchasePanel, true);
end

function Lua_ProbationFairyPurchaseWindow:showWin(param)
	self:superCall("showWin", param);

	self.purchasePanel:setData(param);
	self.dragContainer:updateChildPos();
	self.dragContainer.canDrag = self.purchasePanel:getHeight() > 220;
end

function Lua_ProbationFairyPurchaseWindow:onPurchaseClick(go)
	local param = {};
	param.fairyPackItemData = DataCenter.fairyData.fairyList[self.showData.fairyVo.referenceIndex];
	param.winType = 3;
	Lua_WindowUtil.openWin("Lua_FairyExpireWindow", WinParam.ACTION_OPEN, param);
	self:hide();
end

function Lua_ProbationFairyPurchaseWindow:dispose()
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ProbationFairyPurchasePanel = class("Lua_ProbationFairyPurchasePanel", Lua_DragContainerItem);
function Lua_ProbationFairyPurchasePanel:ctor(p, pWin)
	self.pWin = pWin;
	self.height = 200;
	self:superCall("ctor", p);
end

function Lua_ProbationFairyPurchasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.toolImage = Lua_ToolImage.new(self.content);
	self.toolImage:setLocation(0, 70, 0);
	self.toolImage:setCanClick(false);
	
	self.title1 = UICreate.createLabel(self.content, LanUtil.getValue(123502), -228, 5, 50, 22, 24);
	self.title1.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.title1.pivot = UIWidget.Pivot.TopLeft;
	self.title1:setDepth(5);

	self.desTxt = UICreate.createLabel(self.content,"",-2,55,336,22,24);
	self.desTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.desTxt.pivot = UIWidget.Pivot.TopLeft;
	self.desTxt:setDepth(5);

	self.title2 = UICreate.createLabel(self.content, LanUtil.getValue(123503), 0, 0, 50, 22, 24);
	self.title2.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.title2.pivot = UIWidget.Pivot.TopLeft;
	self.title2:setDepth(5);

	self.countDownTxt = UICreate.createLabel(self.title2.mainContent, "", 120, 0, 50, 22, 24);
	self.countDownTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.countDownTxt.pivot = UIWidget.Pivot.TopLeft;
	self.countDownTxt:setDepth(5);

	self.expiredTips = UICreate.createLabel(self.content, LanUtil.getValue(123504), -2, 55, 472, 22, 24);
	self.expiredTips.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.expiredTips.pivot = UIWidget.Pivot.TopLeft;
	self.expiredTips:setDepth(5);
end

function Lua_ProbationFairyPurchasePanel:setData(param)
	self.equipedFairyItem = DataCenter.fairyData.equipedfairyItem;

	self.fairyVo = param.fairyVo;
	self.fairyItem = self.fairyVo.toolVo;
	self.toolImage.data = self.fairyItem;

	local attribute = self.fairyItem.attribute;
	local attrId;
	local attrTxt;
	local lastLabel;
	local sX = 22;
	local sY = 5;
	for k,v in pairs(attribute) do
		attrId = Lua_ThingDefine.getParamId(tostring(k));
		attrTxt = UICreate.createLabel(self.content, "", -2, 55, 472, 22, 24);
		attrTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
		attrTxt.pivot = UIWidget.Pivot.TopLeft;
		attrTxt.text = "[00E125]"..LanUtil.formateStr(Lua_ThingDefine.getParamName(attrId), tostring(v));
		attrTxt:setDepth(5);
		
		if lastLabel == nil then
			attrTxt:setLocation(-108, 5);
		else
			local lastLabelPos = lastLabel.mainContent.transform.localPosition;
			local curLabelPos = attrTxt.mainContent.transform.localPosition;
			if lastLabelPos.x + lastLabel.width + sX + attrTxt.width < 220 then
				attrTxt:setLocation(lastLabelPos.x + lastLabel.width + sX,lastLabelPos.y);
			else
				attrTxt:setLocation(-108, lastLabelPos.y - lastLabel.height - sY);
			end
		end
		lastLabel = attrTxt;
	end

	self.desTxt.text = self.fairyVo.des;
	self.desTxt:setLocation(-108, lastLabel.mainContent.transform.localPosition.y - lastLabel.height - sY);
	self.title2:setLocation(-228, self.desTxt.mainContent.transform.localPosition.y - self.desTxt.height - sY - 15);
	self.expiredTips:setLocation(-228, self.title2.mainContent.transform.localPosition.y);
	self.height = 100 - self.expiredTips.mainContent.transform.localPosition.y + self.expiredTips.height;

	self:updateCountDownState();
	Lua_CommonUtil.addTimer("PROBATION_FAIRY", 0.5, self, self.updateCountDownState);
end

function Lua_ProbationFairyPurchasePanel:updateCountDownState()
	if self.equipedFairyItem ~= nil then
		local leftTime = self.equipedFairyItem.fairyVo.expireTimes - DataCenter.roleData.serverTime;
		if leftTime > 0 then
			self.title2:setEnable(true);
			self.countDownTxt:setEnable(true);
			self.expiredTips:setEnable(false);
			self.countDownTxt.text = "[FF1616]"..TimeTransform.getInstance():transSeconds15(leftTime, true);
		else
			self.title2:setEnable(false);
			self.countDownTxt:setEnable(false);
			self.expiredTips:setEnable(true);
			self.pWin:hide();
		end
	else
		self.title2:setEnable(false);
		self.countDownTxt:setEnable(false);
		self.expiredTips:setEnable(true);
		self.pWin:hide();
	end
end

function Lua_ProbationFairyPurchasePanel:getHeight()
	return self.height;
end

function Lua_ProbationFairyPurchasePanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.updateCountDownState);
	self:superCall("dispose");
end